class placesForm {

    constructor(){
        this.init()
    }

    init(){
        this.Akey = document.getElementById("Akey");
        this.sendBtn = document.getElementById('sendBtn');
        this.sendBtn.addEventListener('click', this.send.bind(this))
    
        this.actionSel = document.getElementById("actionSel")
        this.actionSel.value = "Добавить"
        this.actionSel.addEventListener('change', this.actChange.bind(this));
        this.editor = document.getElementById('editor');
        this.actChange();
        
        
    }


    async actChange(){
        this.editor.innerHTML = "";
        this.groupSel = null;
        this.pointNum = null;
        console.log(this.actionSel.value)
        if (this.actionSel.value === "Добавить") {
            this.editor.innerHTML += `<h2>Количество точек</h2>
                                      <input type="number" id="pointNum" min=1>`
            this.editor.innerHTML += `<h2>Название группы</h2>
                                      <input type="text" id="name" name="groupName">
                                      <div id="pointsArea"></div>`
            this.groupName = document.getElementById("name")

            this.pointNum = document.getElementById("pointNum");
            this.pointNum.addEventListener('change', this.pointsChange.bind(this))
            this.pointsChange();                          
        }
        if (this.actionSel.value === "Удалить"){
            this.editor.innerHTML += `<h2>Название группы</h2>
                                      <select id="groupSel" name="groupName"></select>`
            this.groupSel = document.getElementById("groupSel")

            const res = await fetch("http://" + document.URL.split('/')[2] + "/klop_in/places.json")
            const groups = await res.json();
            for (let grp in groups){
                this.groupSel.innerHTML += `<option>${grp}</option>`
            }

        }
    }

    pointsChange(){
        this.pointsArea = document.getElementById("pointsArea");
        this.pointsArea.innerHTML = `<h2>Названия точек</h>`
        for (let i = 0; i < this.pointNum.value; i++){
            this.pointsArea.innerHTML += `<input type="text" id="place-${i}"><br>`
        }
    }

    async send(){
        console.log(1);
        let sendData = {
            Akey : this.Akey.value,
            action : { Удалить:"delete", Добавить:"add"}[this.actionSel.value],
        }

        if (sendData.action === "delete"){
            sendData["groupName"] = this.groupSel.value
        } 
        if (sendData.action === "add"){
            sendData["groupName"] = this.groupName.value
            let points = []
            for (let i = 0; i < this.pointNum.value; i++) {
                const curPoint = document.getElementById(`place-${i}`)
                points[i] = curPoint.value
            }
            sendData["points"] = points
        }
        const req_content = {
            method: 'POST',
            headers: {
                'Content-Type': 'application/json'
            },
            body: JSON.stringify(sendData)
        }

        const resp = await fetch( `http://${document.URL.split('/')[2]}/klop_api/add_group`, req_content);
        var msg = new TextDecoder().decode((await resp.body.getReader().read()).value);
        alert(msg);
        //console.log((await resp.body.getReader().read()).value);
        this.actChange();

    }
}

const pf = new placesForm()