module.exports = router;

//Импорт модулей, необжодимых для работы
const express = require('express');
const fetch = require('node-fetch');
const bp = require('body-parser');
const fs = require('fs').promises;

//Тут настраивать путь к срипту бд
const db_jsonadd_url = "http://62.122.196.31/core/jsonadd.php"


//Объяаление паршрута к api
var router = express.Router();

//Создание парсера HTML-запросов
const jsonParser = express.json();
const up = bp.urlencoded({
	extended: false,
})
router.use(up);
router.use(bp.json());

async function sleep(ms) {
	return new Promise((resolve) => {
		setTimeout(() => resolve(), ms);
	});
}

async function readJSON(filePath) {
	try {
	  const data = await fs.readFile(filePath);
	  return(JSON.parse(data))
	} catch (error) {
	  console.error(`Got an error trying to read the file: ${error.message}`);
	}
}

async function writeJSON(filePath, data) {
	try {
	  await fs.writeFile(filePath, data);
	} catch (error) {
	  console.error(`Got an error trying to write to a file: ${error.message}`);
	}
  }


//Обработка запроса отправки данных в базу
router.post('/send', async function(req, res){

	let settings = await readJSON("public/klop_in/settings.json")

	let content = req.body;
	//Формирование запроса
	console.log(content)
	let i = 0
	for (let i in req.body){
		const content = req.body[i]
		const req_content = { 
			method: 'POST',
			headers: {
				'Content-Type': 'application/json'
			},
			body: 	JSON.stringify(content)	
		}
		console.log(content)
		await fetch(db_jsonadd_url, req_content);
		if (settings.delayedSending) await sleep(1000)
	}


	//console.log(req_content, i, Object.keys(req.body).length, (i < req.body.length))
	res.send("200");
})

router.post('/dsend', async function(req, res){
	let content = req.body;
	//Формирование запроса
	const req_content = { 
		method: 'POST',
		headers: {
			'Content-Type': 'application/json'
		},
		body: 	JSON.stringify(content)
	}

	await fetch(db_jsonadd_url, req_content);
	res.send("200");
})



router.post('/add_group', async function(req, res){
	const keyList = await readJSON("public/klop_in/settings.json")
	if (keyList.keys.indexOf(req.body.Akey) === -1) {
		res.status(403);
		res.send("Неверный api key.")
		return
	}
	let placesData = await readJSON("public/klop_in/places.json");
	//console.log(placesData)

	if (req.body.action === "delete"){
		delete placesData[req.body.groupName]
		writeJSON("public/klop_in/places.json", JSON.stringify(placesData))
		res.send(`Группа \"${req.body.groupName}\" успешно удалена.`)
		return
	}
	if (req.body.action === "add"){
		placesData[req.body.groupName] = req.body.points
		writeJSON("public/klop_in/places.json", JSON.stringify(placesData))
		res.send(`Группа \"${req.body.groupName}\" успешно добавлена.`)
		return
	}
})

module.exports = router;
